using System.Windows;

namespace Hardcodet.Editors
{
  /// <summary>
  /// A behavior that allows to be bound to any <see cref="DependencyProperty"/>
  /// of an arbitrary source.
  /// </summary>
  public class CustomFocusBehavior : FocusBehaviorBase
  {
    #region BoundSource


    public static readonly DependencyProperty BoundSourceProperty =
      DependencyProperty.Register("BoundSource", typeof (DependencyProperty), typeof (CustomFocusBehavior));


    public DependencyProperty BoundSource
    { 
      get { return (DependencyProperty)GetValue(BoundSourceProperty); }
      set { SetValue(BoundSourceProperty, value); }
    }

    #endregion


    protected override DependencyProperty GetSourceProperty()
    {
      return BoundSource;
    }
  }
}