using System;
using System.Windows;
using System.Windows.Data;
using System.Windows.Interactivity;
using WpfApplication1;

namespace Hardcodet.Editors
{
  public abstract class FocusBehaviorBase : Behavior<FrameworkElement>
  {
    protected abstract DependencyProperty GetSourceProperty();


    protected override void OnAttached()
    {
      var focusController = AssociatedObject.DataContext as IFocusController;
      if(focusController == null) return;

      var elem = AssociatedObject as UIElement;
      var handler = new FocusControl.FocusControlHandler(elem, GetSourceProperty());
      focusController.MoveFocus += handler.HandleMoveFocus;
    }
  }
}