﻿using System;
using System.Windows;
using System.Windows.Data;
using System.Windows.Markup;

namespace WpfApplication1
{
    public class FocusBinding : MarkupExtension
    {
        public FocusBinding()
        {
        }

        public Binding Binding { get; set; }

        public override object ProvideValue(IServiceProvider serviceProvider)
        {
            var provideValueTarget = serviceProvider.GetService(typeof(IProvideValueTarget)) as IProvideValueTarget;
            if (provideValueTarget != null)
            {
                var element = provideValueTarget.TargetObject as DependencyObject;
                var property = provideValueTarget.TargetProperty as DependencyProperty;
                FocusControl.SetFocusableProperty(element, property);
            }
            return this.Binding.ProvideValue(serviceProvider);
        }
    }
}